# $Id: ConnectServer.pm,v 1.5 2005/12/12 07:22:16 hi-lo Exp $
package ConnectServer;
use Socket;
require Exporter;
use strict;

use lib '../conf';
use LibConfig qw($tcp_timeout $fk_cmd $fk_err);
use FK_SSLeayHandle;

use Net::SSLeay qw(die_now die_if_ssl_error) ;

#my $tcp_timeout=5;

use vars qw(@ISA @EXPORT);
@ISA = qw(Exporter);
@EXPORT = qw(connect_server_tcp enable_ssl_tcp set_ready_bit);

sub connect_server_tcp ($$;$) {
  # $BBh(B1$B0z?t(B: $B%[%9%HL>(B or IP$B%"%I%l%9(B
  # $BBh(B2$B0z?t(B: $B%]!<%HHV9f(B
  # $BBh(B3$B0z?t(B($B%*%W%7%g%J%k(B): $B%?%$%`%"%&%H;~4V(B($BIC(B)

	my($target,$port,@rest) = @_;

  if ( $#rest >= 1 ){
    $tcp_timeout=shift @rest;
  }
  
  # inet_aton$B$O(BDNS$B$b0z$$$F$/$l$k(B. 
  my $target_ip = inet_aton($target);

  # for debug
  # inet_aton$B$N=PNO$r(BIP$B%"%I%l%9$KLa$9(B
  my $ipaddr_str = inet_ntoa($target_ip);
  #printf("connect to %s:%s => [%s]:%s\ntimeout = %s\n",$target,$port,$ipaddr_str,$port,$tcp_timeout);
  
  my $returnSOCK;
  
  eval {
    #$SIG{'ALRM'} = \&timeout_alarm;
	  $SIG{'ALRM'} = sub { die "timeout" }; 
      # eval$BFb$G$N(Bdie$B$O(B, eval{}$B$NJVCM$r(Bundef$B$H$9$k0UL#(B. 
      # $B?F$4$H;`$s$@$j$7$J$$$+$i$40B?4$r(B. 
    
    my $remote = sockaddr_in($port, $target_ip);
	  my $proto = getprotobyname('tcp');
  
	  socket(SOCK, PF_INET,SOCK_STREAM, $proto) or die "Socket error";
	
    alarm($tcp_timeout);
	  connect(SOCK,$remote) or die "Connect error";
	  alarm(0);
   
    # socket$B$r%P%C%U%!$7$J$$$h$&$K$9$k(B. 
    # 
    # $B0J2<$N(B3$B9T$r$+$C$3$h$/=q$/$H(B
    # select( (select(SOCK), \|=1)[0] );
    # $B$K$J$k(B. 
    # $BF0:n86M}(B:
    #   $B$^$:(B, (select(SOCK), \|=1)[0] $B$NItJ,$,I>2A$5$l$k(B. 
    #   $B$3$l$O(B, $BL5L>$NG[Ns$r0UL#$7$F$$$k(B. 
    #   $BG[Ns$NMWAG$rF@$k$?$a$K(B, Perl$B$O(B, select(SOCK)$B$NJVCM$H(B \|=1 $B$NJVCM$r=g$K7W;;$9$k(B. 
    #   $B>\$7$/=R$Y$k$H(B....
    #   select(SOCK)$B$N=PNO$O(B, $B2<5-$N(B$oldFileHandle$B$KAjEv$9$k(B. 
    #   $BB3$$$F(B, \|=1 $B$r7W;;$9$k(B. $B$3$NCJ3,$G(B, $B2<5-$N(B2$B9TL\$,<B9T$5$l$?$N$HF1Ey$K$J$k(B. 
    #   $B$=$7$F(B, (select(SOCK), \|=1)[0] $B$O(B, $oldFileHandle$BAjEv$NCM$rJV$9(B. 
    #   
    #   $B$=$N$?$a(B, $BA4BN$H$7$F$O(B, $B$3$NG[Ns$N(B1$BHVL\$NMWAG$r:F$S(Bselect$B$9$k$3$H$K$J$k(B. 
    my $oldFileHandle = select(SOCK);
    $| = 1;
    select($oldFileHandle);

    #return *SOCK;
    $returnSOCK = *SOCK
    # $B$3$N4X?t$G<hF@$7$?(BSocket$B$O(B, $BMxMQ@h$G$A$c$s$H(Bclose$B$7$F$M!<(B. 
  };

  # $SIG{'ALRM'}$B$,8F$P$l$F(B, die$B$,<B9T$5$l$?$i(B, alarm(0)$B$,9T$o$l$J$$(B. 
  alarm(0);
  
  # eval $B4X?tFb$G(B die $B$,<B9T$5$l$?$i(B, $B%a%C%;!<%8$,(B$@$B$K3JG<$5$l$F$$$k(B. 
  # $B@5>o$K<B9T$5$l$?$H$-(B, $@$B$O(Bundef
  if ($@) { 
  #  if ($@ =~ /timeout/){
  #    print STDERR "timeout $target:$port\n"
  #  }
    return undef; 
  }

  return $returnSOCK;

  # $B$3$N4X?t$N;HMQNc$O(B, 2$B$D$"$k(B. 
  # 1$B$D$O(B, $B2<5-$N(Bset_ready_bit$B$N;HMQNc$r;29M$K$7$F$/$@$5$$(B. 
  # $B$b$&0l$D$O(Beval{}$B$H(Balarm()$B$r;H$&(B. 
  # 
  #eval{
  #  $SIG{'ALRM'} = sub { die "timeout" }; 
  #
  #  print $SOCK "HEAD / HTTP/1.0","\xd\xa\xd\xa"; # CR=\xd, LF=\xa mac$B$G$O(B, \r$B$H!@(Bn$B$N0UL#$,5UE>$7$F$$$k(B. 
  #  print $OUT "HEAD / HTTP/1.0","\n\n";
  #
  #  alarm($timeout);
  #
  #  while (<$SOCK>) {
  #    chomp;
  #    print $OUT $_,"\n";
  #  }
  #
  #  alarm(0);
  #};
  #
  #alarm(0);
  #
  #close($SOCK);
  #
  # 
}

sub enable_ssl_tcp ($$;$$){
  # $BBh(B1$B0z?t(B: TCP$B%=%1%C%H$X$N%]%$%s%?(B
  # $BBh(B2$B0z?t(B: $B%a%C%;!<%8$r=PNO$9$k%U%!%$%k%O%s%I%k(B
  # $BBh(B3$B0z?t(B: $B%?!<%2%C%H%[%9%H(B
  # $BBh(B4$B0z?t(B: $B%]!<%HHV9f(B
 
  my $SOCK_tmp = shift @_;
  my $OUT = shift @_;
  my $target = shift @_ if ($#_ >= 0);
  my $port = shift @_ if ($#_ >= 0);
  
  
  # $BHs(BSSL$B%=%1%C%H$r(BSSL$B$K$9$k(B. 
  # $B$I$&$b$3$N:n6H$K$O(B30$BIC$NBT$A$,$"$k$_$?$$(B. 
  #
  # SSL$B$G$J$$$H$3$m$KBP$7$F(BSSL$B2=$7$h$&$H$7$?$i(B, $BBT$AB3$1$F$7$^$&(B.
  eval{
    $SIG{'ALRM'} = sub { die "timeout" };
    alarm($tcp_timeout);
    print $OUT eval ($fk_cmd) . "Securing Connection...\n";
    print $OUT eval ($fk_cmd) . "Using " ;
    #tie(*SSL, "Net::SSLeay::Handle", \$SOCK_tmp); # Debug $B%a%C%;!<%8$,$H$j$?$$$N$G%5%V%/%i%9$rMxMQ(B
    # $B=PNO$,(BSTDOUT$B$K=P$5$l$k$N$G(B, STDOUT$B$rJQ99(B
    my $old_fh = select($OUT);
    tie(*SSL, "lib::FK_SSLeayHandle", $SOCK_tmp);
    select($old_fh);
    print $OUT eval ($fk_cmd) . "Connection is secured if Using Cipher is NOT '(NONE)'.\n";
    alarm(0);
  };
  alarm(0);
  # eval $B4X?tFb$G(B die $B$,<B9T$5$l$?$i(B, $B%a%C%;!<%8$,(B$@$B$K3JG<$5$l$F$$$k(B.
  # $B@5>o$K<B9T$5$l$?$H$-(B, $@$B$O(Bundef
  if ($@) {
    if ($@ =~ /timeout/){
      print $OUT eval ($fk_err) . "Cannot Enable SSL\n";
      return undef;
    }
  }

  #my $SSL_SOCK = \*SSL;
  return \*SSL;

  # $B%=%1%C%H$r:n@.$;$:$K(BNet::SSLeay::Handle (SSL$BDL?.(B)$B$r;H$&J}K!(B
  # my ($host, $port) = ("localhost", 443);
  #
  # tie(*SSL, "Net::SSLeay::Handle", $host, $port);
  # # $B$3$3$G:n$C$?%U%!%$%k%O%s%I%k(BSSL$B$rJQ?t$KF~$l$k$H$-$O(B,
  # # my $ssl_sock = \*SSL
  # # $B$H$$$&Iw$K=q$/(B
  # print SSL "GET / HTTP/1.0\r\n";
  # shutdown(\*SSL, 1);
  # print while (<SSL>);
  # close SSL;

  # $BHs(BSSL$B%=%1%C%H$r:n$k$K$O(B, Net::SSLeay::Handle$B$r;H$C$F(B
  # $B$3$s$JIw$K=q$/$3$H$b$G$-$k(B.
  # $socket = Net::SSLeay::Handle->make_socket($host, $port);
}

sub enable_ssl_tcp_old ($$;$) {
  # $BBh(B1$B0z?t(B: TCP$B%=%1%C%H(B
  # $BBh(B2$B0z?t(B: SSL$B2=$5$l$?$H$-$N0E9f%"%k%4%j%:%`$rJ]B8$9$k%]%$%s%?(B
  # $BBh(B3$B0z?t(B($B%*%W%7%g%J%k(B): $B%?%$%`%"%&%H;~4V(B($BIC(B)

	my($SOCK,$cipher,@rest) = @_;

  if ( $#rest >= 1 ){
    $tcp_timeout=shift @rest;
  }

  # $BDc%l%Y%k$N(BNet::SSLeay$B4X?t$r;H$&$H$-$O(B, $B0J2<$rF~$l$J$$$H$$$1$J$$$i$7$$(B. 
  Net::SSLeay::load_error_strings();
  Net::SSLeay::SSLeay_add_ssl_algorithms();
  Net::SSLeay::randomize();

  my $ctx = Net::SSLeay::CTX_new() or die_now("Failed to create SSL_CTX $!");
  Net::SSLeay::CTX_set_options($ctx, &Net::SSLeay::OP_ALL) and
    die_if_ssl_error("ssl ctx set options");
  my $ssl = Net::SSLeay::new($ctx) or die_now("Failed to create SSL $!");
  
  eval {
    $SIG{'ALRM'} = sub { die "timeout" }; 
    alarm($tcp_timeout);

    Net::SSLeay::set_fd($ssl, fileno($SOCK));
    $ctx = Net::SSLeay::CTX_new() or die_now("Failed to create SSL_CTX $!");
    my $res = Net::SSLeay::connect($ssl) and die_if_ssl_error("ssl connect");
    alarm(0);
  };

  # $SIG{'ALRM'}$B$,8F$P$l$F(B, die$B$,<B9T$5$l$?$i(B, alarm(0)$B$,9T$o$l$J$$(B. 
  alarm(0);

  # eval $B4X?tFb$G(B die $B$,<B9T$5$l$?$i(B, $B%a%C%;!<%8$,(B$@$B$K3JG<$5$l$F$$$k(B. 
  # $B@5>o$K<B9T$5$l$?$H$-(B, $@$B$O(Bundef
  if ($@) { 
  #  if ($@ =~ /timeout/){
  #    print STDERR "timeout $target:$port\n"
  #  }
    return undef; 
  }

  $$cipher = Net::SSLeay::get_cipher($ssl);

  #$B%5!<%P$N>ZL@=q$r<hF@(B
  #my $cert = Net::SSLeay::get_peer_certificate($ssl);

  return $ssl;
} 

sub set_ready_bit {
  # 1$B8D0J>e$N%U%!%$%k%O%s%I%k$r<u$1<h$j!"(Bfileno $B$G3F%U%!%$%k%O%s%I%k$N(B
  # $B%G%#%9%/%j%W%?HV9f$rD4$Y!"$=$l$KBP1~$9$k%S%C%H$rN)$F$?%G!<%?$rJV$9!#(B
  # $BNc$($P(B
  #   fileno(CLIENT_WAITING)==3
  #   fileno(CLIENT_1)      ==4
  #   fileno(CLIENT_3)      ==6
  # $B$N$H$-!"(B
  #   &set_ready_bit(CLIENT_WAITING, CLIENT_1, CLIENT_3)
  # $B$O(B
  #   01011000
  # $B$H$$$&%G!<%?$rJV$9!#(B

  my @sockets = @_;

  my $r_in="";
  foreach my $sock (@sockets){
    # $r_in $B$N!"1&$+$i?t$($F(B fileno($sock) $BHVL\$N%S%C%H$r(B1$B$K$9$k!#(B
    vec($r_in, fileno($sock), 1)=1;
    #printf("  fileno($sock) $B$O(B %d $B$J$N$G(B \$r_in $B$O(B %s $B$K$J$j$^$9!@(Bn",
    #  fileno($sock), &to_bin($rin),);
  }
  return $r_in;
  
  # $B$3$N4X?t$N;H$$J}(B. 
  # print $SOCK "HEAD / HTTP/1.0","\xd\xa\xd\xa"; # CR=\xd, LF=\xa mac$B$G$O(B, \r$B$H!@(Bn$B$N0UL#$,5UE>$7$F$$$k(B. 
  #
  # my $r_in = &set_ready_bit($SOCK);
  # my $ret = select($r_in, undef, undef, 30); 
  #   # $BCm0U(B: $B$3$N(Bselect$B$O(B, I/O$B2DG=$J%U%!%$%k5-=R;R$rC5$94X?t(B. STDOUT$B$rJQ$($k$b$N$G$O$J$$(B. 
  #   # $B$3$3$G$O(B, I/O$B$,2DG=$J%U%!%$%k5-=R;R$,(B1$B$D$G$b$G$-$k$^$G(B, $B:GBg(B30$BICBT$D(B. 
  #   # $BJVCM$O%9%+%i!<$r5a$a$i$l$F$$$k$N$G(B, I/O$B$,2DG=$K$J$C$?%U%!%$%k5-=R;R$N8D?t$,JV$5$l$k(B. 
  #   # $B$3$N4X?t$rH4$1$?$H$-$K(B, $r_in$B$G(B1$B$,N)$C$F$$$k%S%C%H$,(BI/O$B2DG=$J%U%!%$%k5-=R;R$N(Bfileno
  #  
  # if ( vec  ($r_in, fileno($SOCK), 1) ){
  #   # $r_in$B$N1&$+$i(Bfileno($SOCK)$BHVL\$N(B1$B%S%C%H$,N)$C$F$$$k(B(1$B$K$J$C$F$$$k(B)$B$+$rD4$Y$k(B. 
  #   while (<$SOCK>) {
  #     chomp;
  #     print $_,"\n";
  #   }
  # }else{
  #   print $OUT "timeout!\n";
  # }
  # close($SOCK);
}

 
1;
