# $Id: misc.pm,v 1.13 2005/12/13 03:08:41 hi-lo Exp $
package misc;
require Exporter;
use strict;

use lib '../conf';
#use LibConfig qw($tcp_timeout $fk_cmd $fk_err $fk_snd $fk_rcv);
use LibConfig;

use vars qw(@ISA @EXPORT);
@ISA = qw(Exporter);
@EXPORT = qw(print2 send_cmd send_smtp_cmd send_ftp_cmd send_pop_cmd 
  send_imap_cmd send_nntp_cmd expand_port_range fold_port_range
  get_nmap_grepable_log);

sub print2 (*;$) {
  # $B8=:_(Bselect$B$5$l$F$$$k%U%!%$%k%O%s%I%k(B($BDL>o$O(B, STDOUT)$B$H(B
  # $BBh(B1$B0z?t$GM?$($i$l$?%U%!%$%k%O%s%I%k$,<($9@h$NN>J}$K(B
  # $BBh(B2$B0z?t$NJ8;zNs$r=q$-9~$`(B. ($BBh(B1$B0z?t$,(Bundef$B0J30$N>l9g$K8B$k(B)
  # 
  # $B8F$S=P$7Nc(B. 
  # 1. $B8=:_(Bselect$B$5$l$F$$$k%U%!%$%k%O%s%I%k$N$_$K=q$-=P$9(B
  #    print2 (undef, "message1");
  #
  # 2. $BNc(B1$B$K2C$((B, $BBh(B1$B0z?t$N%U%!%$%k%O%s%I%k$G<($9%U%!%$%k$K$b=q$-=P$9(B. 
  #    open OUTFILE, "| $NKF > $outfile"
  #    print2 (\*OUTFILE, "message");

  my($handle,$msg) = @_;

  print "$msg";
  print $handle "$msg" if (defined $handle);
}

sub to_bin {
  # $B0z?t$r<u$1<h$j!"(B2$B?J?t$NJ8;zNs(B(010111...)$B$KJQ49$7$FJV$9!#(B
  return unpack "B*", $_[0];
}

sub send_cmd($$$;@){
  # $BBh(B1$B0z?t(B $B%=%1%C%H$X$N%]%$%s%?(B
  # $BBh(B2$B0z?t(B $B%=%1%C%H$XAw?.$9$k%3%^%s%I(B ($B2~9T$r4^$^$;$k$3$H(B)
  # $BBh(B3$B0z?t(B $B%=%1%C%H$+$i$N1~Ez$r=q$-=P$9%U%!%$%k%O%s%I%k$X$N%]%$%s%?(B
  # $BBh(B1$B0z?t$GM?$($i$l$?%=%1%C%H$KBP$7(B, $BBh(B2$B0z?t$NJ8;zNs$rAw=P$7(B, 
  # $BAw=P$7$?J8;zNs$H(B, $B$=$N1~Ez$rBh(B3$B0z?t$GM?$($i$l$?%U%!%$%k%O%s%I%k$X(B
  # $B=q$-=P$9(B
  # $BBh(B4$B0z?t(B $B%3%^%s%I$N=*N;>r7o(B ($B@55,I=8=(B)
  #         $BNc(B: '^\d\d\d '
  # $BBh(B5$B0z?t(B $BJQ?t$NDj5A$J$I(B, Perl$B%3%^%s%I$H$7$F<B9T$G$-$kJ8;zNs(B. 

  my ($socket, $cmd, $out, @rest) = @_;
  
  # $B%=%1%C%H$N>pJs$r<hF@$9$k(B. 
  #my $sockaddr = getsockname($socket);
  #my ($port, $addr) = unpack_sockaddr_in($sockaddr);
  
  # $B=*N;>r7o(B. $B$3$N@55,I=8=$,1~Ez$NCf$K8+$i$l$?$i(B, $B1~EzBT$A$r=*N;$7(B
  # $B4X?t$b=*N;$9$k(B. 
  #my $finish_regex = '^\d\d\d ';

  my $finish_regex = undef;
  
  $finish_regex = shift @rest if ($#rest >=0 );

  my $eval_target = undef;

  $eval_target = shift @rest if ($#rest >=0 );
  eval ($eval_target);
 
  eval{
    $SIG{'ALRM'} = sub {die "timeout" };

    print $socket $cmd;
    print $out eval($fk_snd) . "$cmd";

    alarm($tcp_timeout);

    if ( defined $finish_regex ){
      # $B=*N;>r7o$,$"$k>l9g(B
      while (<$socket>){
        chomp;
        print $out eval($fk_rcv) . "$_\n";
        last if ($_ =~ /$finish_regex/);
      }
    }else{
      # $B=*N;>r7o$,$J$$>l9g(B. 
      # $B$R$?$9$iBT$AB3$1$k$3$H$K$J$k$N$G(B, 
      # $B%?%$%`%"%&%H$^$G$3$3$G;_$^$k(B
      while (<$socket>){
        chomp;
        print $out eval($fk_rcv) . "$_\n";
      }
    }
      
    alarm (0);
  };

  alarm (0);
  return;
}

sub send_smtp_cmd($$$;@){
  #SMTP$B$N1~Ez$O(B, '^\d\d\d '$B$,$-$?$i:G=*9T(B
  #return send_cmd($_[0], $_[1], $_[2], '^\d\d\d ');
  return send_cmd(shift @_, shift @_, shift @_, '^\d\d\d ', @_);
}

sub send_ftp_cmd($$$;@){
  #FTP$B$N1~Ez$O(B, '^\d\d\d '$B$,$-$?$i:G=*9T(B
  #return send_cmd($_[0], $_[1], $_[2], '^\d\d\d ');
  return send_cmd(shift @_, shift @_, shift @_, '^\d\d\d ', @_);
}

sub send_pop_cmd($$$;@){
  #POP$B$N1~Ez$O(B, '^[\+\-]'$B$,$-$?$i:G=*9T(B
  #return send_cmd($_[0], $_[1], $_[2], '^[\+\-]');
  return send_cmd(shift @_, shift @_, shift @_, '^[\+\-]', @_);
}

sub send_imap_cmd($$$;@){
  #IMAP$B$G$O(B, $B%3%^%s%I$NA0$K%?%0$rIU$1(B, 
  #$B$=$N%?%0$HF1$8J8;zNs(B+$B6uGr(B1$B$D$G;O$^$k1~Ez$,$-$?$i:G=*9T(B
  #return send_cmd($_[0], "A001 $_[1]", $_[2], '^A001 ');
  return send_cmd(shift @_, "A001 " . shift @_, shift @_, '^A001 ', @_);
}

sub send_nntp_cmd($$$;@){
  #FTP$B$N1~Ez$O(B, '^\d\d\d '$B$,$-$?$i:G=*9T(B
  #return send_cmd($_[0], $_[1], $_[2], '^\d\d\d ');
  return send_cmd(shift @_, shift @_, shift @_, '^\d\d\d ', @_);
}

sub expand_port_range($){
  # $BBh(B1$B0z?t(B: $B%]!<%H$N%l%s%8(B
  #   $BNc(B: 1-1024,5000-5050,6000-6060
  # $BJVCM(B: $B;XDj$5$l$?%]!<%H$,F~$C$?G[Ns(B.

  my $port_ranges = shift @_;
  my @ranges = split /,/, $port_ranges;
  my @ports;
  foreach my $range (@ranges){
    my @range_start_end = split /-/, $range;
    return undef if $range_start_end[0] =~ /\D/;
    return undef if ($range_start_end[1] != undef && $range_start_end[1] =~ /\D/);
    push @ports, $range_start_end[0] if (! defined $range_start_end[1] );
    for (my $i=$range_start_end[0]; $i<=$range_start_end[1]; $i++){
      push @ports, $i;
    }
  }
  return @ports;
}

sub fold_port_range(@){
  # $BBh(B1$B0z?t(B: $B%]!<%H$N%l%s%8$,F~$C$?G[Ns(B.
  #   $BNc(B: (1, 2, 3, 4, 50, 60)
  # $BJVCM(B $B%]!<%H$N%l%s%8(B
  #   $BNc(B: 1-4,50,60

  my @ranges = sort {$a <=> $b;} @_;
  my $old_port = shift @ranges;
  my $return_range = "$old_port";

  foreach my $new_port (@ranges){
    #$B%]!<%H$r$R$H$D<h$j=P$7$F(B...
    #
    if($old_port+1 == $new_port){
      # $B0JA0$N$b$N$HO"HV$G$"$l$P(B...
      # $B:#$NCM$rJ]B8(B
      $old_port = $new_port;
      # $BJVCM$K$J$k$b$N$N=*$o$j$K%O%$%U%s$,IU$$$F$$$l$P(B, $B2?$b$7$J$$(B.
      next if ($return_range =~ /-$/);
      $return_range .= '-';
      next;
    }else{
      # $BO"HV$G$O$J$$>l9g(B.
      if ($return_range =~ /-$/){
        # $BJVCM$K$J$k$b$N$N=*$o$j$K%O%$%U%s$,IU$$$F$$$l$P(B,
        # $B8E$$CM$r$R$H$DA0$N%l%s%8$N%(%s%I$H$7$FJ]B8$7$F(B,
        # $B:#$N%]!<%H$r?7$7$$%l%s%8$N%9%?!<%H$K$9$k(B.
        $return_range .= "$old_port,$new_port";
        $old_port = $new_port;
      }else{
        # $BJVCM$K$J$k$b$N$N=*$o$j$K%O%$%U%s$,IU$$$F$$$J$1$l$P(B
        # $B:#$N%]!<%H$r?7$7$$%l%s%8$N%9%?!<%H$K$9$k(B.
        $return_range .= ",$new_port";
        $old_port = $new_port;
      }
    }
  }
  #$B:G8e$^$G=*$o$C$?$i(B.
  if ($return_range =~ /-$/){
    # $BJVCM$K$J$k$b$N$N=*$o$j$K%O%$%U%s$,IU$$$F$$$l$P(B,
    # $B8E$$CM$r$R$H$DA0$N%l%s%8$N%(%s%I$H$7$FJ]B8(B
    $return_range .= "$old_port";
  }
  return $return_range;
}

######################################
# nmap$B$N(Bgrepable log$B%U%!%$%k$+$i(B, $B%]!<%H$N>u67Kh$KJ,N`$7$?%O%C%7%e$r<hF@$9$k(B. 
# $BMxMQNc(B
# my %scan_targets = get_nmap_grepable_log($ARGV[0]);
#
#foreach my $host (keys %scan_targets){
#  print "+++++++++++++++++++++++++++++++++++++++++++++++++\n";
#  print "$host\n";
#  print "tcp\n";
#  foreach my $state (keys %{$scan_targets{$host}->{'tcp'}}){
#    print "**$state**:". $scan_targets{$host}->{'tcp'}->{$state} . "\n";
#    print "**$state port num**=". $scan_targets{$host}->{'tcp_num'}->{$state} . "\n";
#  }
#  print "udp\n";
#  foreach my $state (keys %{$scan_targets{$host}->{'udp'}}){
#    print "**$state port num**=". $scan_targets{$host}->{'udp_num'}->{$state} . "\n";
#  }
#}

sub get_nmap_grepable_log($){
  # $BBh(B1$B0z?t(B: nmap$B$N(Bgrepable log$B%U%!%$%kL>(B
  # $BJVCM(B: 
  #   hash{$B%[%9%HL>(B}->
  #     {[udp, tcp]}->{[open, closed, filttered, open|filttered]}->
  #        {$B3:Ev$9$k%]!<%H(B}
  #     {[udp_num, tcp_num]}->{[open, closed, filttered, open|filttered]}->
  #        {$B3:Ev$9$k%]!<%H$N8D?t(B}

  my $nmap_glog_file = shift @_;
    
  my %scan_targets = ();
  my @open_ports = ();
  my %tcp_port_status = ();
  my %udp_port_status = ();
  my $tcp_scanned_ports;
  my $udp_scanned_ports;
  my $default_state;
  my $host;

  open (NMAP_GLOG, "< $nmap_glog_file") or die "Can't open $nmap_glog_file: $!";

  while (<NMAP_GLOG>){
    # '#'$B$G;O$^$k9T$O%3%a%s%H(B
    next if (/^#/ and not (/^# Ports scanned:/));
    chomp; 

    if (/^# Ports scanned:/){
      # $B%9%-%c%s$7$?%]!<%H$NHO0O$rD4$Y$k(B
      $tcp_scanned_ports = $_;
      $udp_scanned_ports = $_;
      $tcp_scanned_ports =~ s/.*TCP\(\d+;([\d\-,]+)\).*/\1/gc;
      $udp_scanned_ports =~ s/.*UDP\(\d+;([\d\-,]+)\).*/\1/gc;
      #print "$tcp_scanned_ports\n";
      #print "$udp_scanned_ports\n";
      
      next;
    }

    # $B?GCG7k2L$N$"$k9T(B
    # $B3F%U%#!<%k%I(B(Host, Ports$B$J$I(B)$B$O%?%V$G6h@Z$i$l$F$$$k(B.
    my @fields = split /\t/, $_;

    for my $field (@fields){
      if ($field =~ /^Host:/){
        # $B%9%-%c%s$7$?%[%9%H(B
        $host = $field;
        $host =~ s/^Host:\s+([^\s]*)\s+\([^\)]*\).*/\1/gc;
        next;
      }
      
      if ($field =~ /^Ignored State:/){
        # $BNs5s$5$l$J$$%]!<%H$N%9%F!<%?%9(B
        $default_state = $field;
        $default_state =~ s/^Ignored State:\s+([^\s]*)\s+\(\d+\).*/\1/gc;
        next;
      }
 
      if ($field =~ /^Status:/){
        if ($default_state =~ /^$/ ){
          # $BA4%]!<%H$,(Bfiltered$B$N>l9g(B, $B0J2<$N$h$&$K$K=PNO$5$l$k$N$_$G(B, 
          # $B%G%U%)%k%H$N%]!<%H>uBV$,J,$+$i$J$$(B. 
          # "Host: 192.168.0.1 () Status: Up"
          # $B$=$N$?$a(B, $default_state$B$,ITL@$N>l9g$O(B, filtered$B$K$9$k(B. 
          # $BB8:_$9$k$+J,$+$i$J$$$,(B, Ignored State:$B$H(BStatus:$B$,N>J}$"$k>l9g$,(B
          # $B$"$k2DG=@-$,$"$k$?$a(B. 
          $default_state = 'filtered';
        }
        next;
      }
      
      # Ports$B0J30$OITMW(B
      next if $field !~ /^Ports: /;
      
      # $BF,$N(B"Ports: "$B$r:o=|(B
      $field =~ s/^Ports: //o;
      
      # $B3F%]!<%H$N7k2L$O(B, ", "$B$G6h@Z$i$l$F$$$k(B.
      my @ports_data = split /, /, $field ;
      for my $port_data (@ports_data){
        # $B3F%]!<%H$N7k2L$N0UL#(B. (http://www.unspecific.com/nmap-oG-output)
        # $B%]!<%HHV9f(B/$B%9%F!<%H(B/$B%W%m%H%3%k(B/$B%*!<%J!<(B/$B%5!<%S%9L>(B/rpcinfo/$B%P!<%8%g%s>pJs(B/
        # ($B:G8e$N(B"/"$B$N8e$m$O8=:_$N=j(B, $B;H$o$l$F$$$J$$(B)
        # $B%9%F!<%H(B: open close filtered open|filtered
        # $B%W%m%H%3%k(B: tcp udp
        # $B%*!<%J!<(B: reverse ident-scan(-I)$B$K$h$C$FF@$i$l$?%5!<%S%9$N%*!<%J!<(B.
        #           nmap 3.70$B0J9_(B, ident-scan$B$,$J$/$J$C$?$N$G(B, $BMxMQ$5$l$J$$$H;W$&(B.
        # $B%5!<%S%9L>(B:
        # rpcinfo: RPC Scan(-sR)$B$K$h$C$FF@$i$l$?(BRPC$B$K4X$9$k>pJs(B
        # $B%P!<%8%g%s>pJs(B: Version Detection (-sV)$B$K$h$C$FF@$i$l$?%5!<%S%9$N%P!<%8%g%s(B
        my ($port, $state, $proto, $owner, $svc_name, $rpc_info, $ver_info, $dummy)
          = split /\//, $port_data;
        
        ## $B%]!<%H$,(Bopen$B$7$F$$$k$b$N$r<hF@(B(open open|filtered)
        #push @open_ports, $port if ($state =~ /^open/);

        if ($proto =~ /tcp/){
          push @{$tcp_port_status{$state}}, $port;
        }elsif ($proto =~ /udp/){
          push @{$udp_port_status{$state}}, $port;
        }
      } 
    }

  foreach my $port_type ('udp', 'tcp'){
    my $port_status;
    if ($port_type =~ /udp/){
      $port_status = \%udp_port_status;
    }elsif ($port_type =~ /tcp/){
      $port_status = \%tcp_port_status;
    }
    
    # $B%G%U%)%k%H$N%9%F!<%?%9$K$J$C$F$$$k%]!<%H$rC5$9(B. 
    my @defined_ports = ();
    for my $state (keys %$port_status){
      # $B7k2L$G;XE&$N$"$C$?%]!<%H(B
      push @defined_ports, @{$$port_status{$state}};
    }
  
    # $B%9%-%c%s$7$?%]!<%H$NF~$C$?G[Ns$r<hF@(B
    my @target_ports;
    if ($port_type =~ /udp/){
      @target_ports = expand_port_range($udp_scanned_ports);
    }elsif ($port_type =~ /tcp/){
      @target_ports = expand_port_range($tcp_scanned_ports);
    }

    my %count = (); 
    foreach my $element (@defined_ports, @target_ports) { $count{$element}++ }
    #$B=EJ#$7$?MWAG(B
    #my @duplication;
    #$B:9J,(B
    my @difference;
    foreach my $element (sort {$a<=>$b;} keys %count) {
      #push @{ $count{$element} > 1 ? \@duplication : \@difference }, $element;
      push @difference, $element if ($count{$element} == 1);
    }
    
    # $B%]!<%HHV9f$N%=!<%H(B
    @difference = sort {$a <=> $b;} @difference;

    @{$$port_status{$default_state}} = @difference;

    for my $state (keys %$port_status){
      # $B=PNOMQ$N%G!<%?$NJ]B8(B
      $scan_targets{$host}->{$port_type}->{$state} = 
        fold_port_range(@{$$port_status{$state}}); 
      # $B3:Ev$9$k%]!<%H?t$b5-O?$7$F$*$/(B. 
      $scan_targets{$host}->{$port_type . "_num"}->{$state} =
        $#{$$port_status{$state}} + 1;
    }
  }
  #$B?GCG7k2L$NF~$C$?9T(B. $B$3$3$G=*$o$j(B.
}

close (NMAP_GLOG);
return %scan_targets;

}


1;
