#!/usr/bin/perl
#
# Finger$B%5!<%P$+$i%f!<%6%j%9%H$r$H$C$F$/$k%3!<%I(B. 
#
# $Id: finger_user.pl,v 1.8 2005/09/07 02:26:19 hi-lo Exp $
use lib '../lib';
use ConnectServer;
use Socket;

use lib '../conf';
use GConfig qw($finger @finger_user $fk_cmd $fk_snd $fk_rcv);

use strict;

my $usage = qq{Usage: $0 [Options] target
target: IP or Hostname
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  -p        port number. (default: 79)

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_o $opt_p $opt_h $opt_s);

getopts('o:p:h') or die $usage;

die $usage if $opt_h;

# $BBP>]%]!<%H$N;XDj$r8!:w(B ($B;XDj$,$J$1$l$P(B79$BHV%]!<%H(B)
my $port = $opt_p ? $opt_p : 79;

# $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
my $target = $ARGV[0];

# $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
die $usage unless  $target ;

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

print $OUT "=====BEGIN=====Target: $target=====" . `date` ;
# finger$B$r;H$&(B. ($B%$%s%?%i%/%F%#%V$J<B9T$G$O$J$$$N$G(B, $B$3$l$G$h$7$H$9$k(B)
for my $user (@finger_user){
  my $command = "$finger -l $user\@$target 2>&1";
  print $OUT eval ($fk_cmd) . "$command\n";

  my @finger_result = `$command`;

  for my $i (@finger_result){
    print $OUT eval($fk_rcv) . $i;
  }
  print $OUT eval ($fk_cmd) . "\n++++++++++\n";
}

print $OUT "=====END=====Target: $target=====" . `date` ;

close(LOG) if $opt_o;

exit 0;




