#!/usr/bin/perl
#
# over SSLT[õT|[gÍASYmFR[h 
#
# $Id: ssl_detail.pl,v 1.8 2005/12/12 08:25:09 hi-lo Exp $
use lib '../lib';
use ConnectServer;

use lib '../conf';
use GConfig qw($timeout $fk_cmd $fk_snd $fk_rcv $fk_err $openssl);

use Socket;
use Net::SSLeay qw(die_now die_if_ssl_error get_peer_certificate) ;

use strict;

my $usage = qq{Usage: $0 [Options] target
target: IP or Hostname
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  -p        port number. (default: 443 )

};

# IvV̉
use Getopt::Std;
use vars qw($opt_o $opt_p $opt_h $opt_s);

getopts('o:p:hs') or die $usage;

# over SSLʐM. 
$opt_s = 1;

die $usage if $opt_h;

# ΏۃzXg(IPAhX)
my $target = $ARGV[0];

# Ώۃ|[g̎w 
# (w肪Ȃ443ԃ|[g)
my $port = $opt_p ? $opt_p : 443 ;

# ΏۃzXg̎w肪Ȃ΃IvV\ďI
die $usage unless $target;

# oIvV΃Ot@C̃I[v
# t@Cnh, Ŏw肵'LOG'
# : t@Cւ͒ǋL܂!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# Ot@C̎w̗L𒲂ׂ(w肪ȂSTDOUT֏o)
my $OUT = $opt_o ? \*LOG : \*STDOUT;
select( (select($OUT), $|=1)[0] );  # obt@O̗}~

# STDERRۑł悤ɂ. 
if ($opt_o){
  open(STDERR, ">&LOG") ;
}else{
  open(STDERR, ">&STDOUT") if (! $opt_o);
}

my $port_comment = ' over SSL' ;
print $OUT "=====BEGIN=====Target: $target:$port$port_comment=====" . `date` ;


# over SSL̒ʐMm߂. 
# ܂ōR[h𗬗p

print $OUT eval ($fk_cmd) . "Check if this port is over SSL...\n";

# \Pbg̍쐬
my $SOCK_tmp = connect_server_tcp($target,$port);

if ( ! defined $SOCK_tmp ){
  print $OUT eval ($fk_err) . "cannot establish connection.\n";
  close(LOG) if ($opt_o);
  exit 1;
}

my $SOCK = $SOCK_tmp;

if ($opt_s){
  # -sIvVw肳Ăꍇ.

  $SOCK = enable_ssl_tcp(\$SOCK_tmp, $OUT, $target, $port);
  if (! defined $SOCK){
    print $OUT eval ($fk_err) . "Cannot Enable SSL: $target:$port\n";
    exit 1;
  }
}

shutdown($SOCK,1) if ($opt_s);
close $SOCK;

print $OUT eval($fk_cmd) . "OK. This port can be over SSL\n";

# Net::SSLeay񋟂჌xAPIgƂɕKv
Net::SSLeay::load_error_strings();
Net::SSLeay::SSLeay_add_ssl_algorithms();
Net::SSLeay::randomize();

$Net::SSLeay::trace = 3;

#$port_type = getservbyname ($port, 'tcp') ;
my $dest_ip = gethostbyname ($target);
my $remote  = sockaddr_in($port, $dest_ip);

my ($ctx, $ssl);

# ԂȂƎv, Ô
eval{
  $SIG{'ALRM'} = sub { die "timeout" };
  alarm($timeout);
  
  socket  (SOCK, &AF_INET, &SOCK_STREAM, 0)  or die "socket error: $!";
  connect (SOCK, $remote) or die "connect error: $!";
  select( (select(SOCK), $|=1)[0] );  # obt@O̗}~

  $ctx = Net::SSLeay::CTX_new() or die_now("Failed to create SSL_CTX $!");
  Net::SSLeay::CTX_set_options($ctx, &Net::SSLeay::OP_ALL)
    and die_if_ssl_error("ssl ctx set options");
  $ssl = Net::SSLeay::new($ctx) or die_now("Failed to create SSL $!");
  Net::SSLeay::set_fd($ssl, fileno(SOCK));   # filenogȂ΂Ȃ܂

  alarm(0);
};

alarm(0);

if ($@){
  print $OUT eval($fk_err) . "Cannot communicate with $target:$port over SSL correctly\n";
  close (LOG) if ($opt_o);
  close (SOCK);
  exit 1;
}

## `FbN\ȈÍASYꗗ̎擾
# @1
#my $i = 0;
#my $p = '';
my @cipher_list;
@cipher_list = ();
#$p=Net::SSLeay::get_cipher_list($ssl,$i);
#push @cipher_list, $p if $p;
#do {
#  $i++;
#  $p=Net::SSLeay::get_cipher_list($ssl,$i);
#  push @cipher_list, $p if $p;
#} while $p;

Net::SSLeay::free ($ssl);
close SOCK;

# @2
@cipher_list = split /:/, `$openssl ciphers`;

#print $OUT eval($fk_cmd) . "$0 can check ....\n";
#foreach my $cipher (@cipher_list){
#  print $OUT eval($fk_cmd) . $cipher . "\n";
#}

#my $command = "$openssl ciphers -v '" . join(':',@cipher_list) . "'";
#print $command . "\n";
#my @i = `$command`;
#print `$command`;

my @available_ciphers = ();

foreach my $cipher (@cipher_list){
  chomp $cipher;
  print $OUT eval($fk_cmd) . "checking if " . $cipher . " is available\n";
  $ctx = undef;
  $ssl = undef;

  # G[Net::SSLeayۉȂG[bZ[Wf̂
  print $OUT eval($fk_err); 

  eval{
    $SIG{'ALRM'} = sub { die "timeout" };
    alarm($timeout);

    socket  (SOCK, &AF_INET, &SOCK_STREAM, 0)  or die "socket error: $!";
    connect (SOCK, $remote) or die "connect error: $!";
    select( (select(SOCK), $|=1)[0] );  # obt@O̗}~

    $ctx = Net::SSLeay::CTX_new() or die("Failed to create SSL_CTX $!");
    Net::SSLeay::CTX_set_options($ctx, &Net::SSLeay::OP_ALL)
      and die_if_ssl_error("ssl ctx set options");
    $ssl = Net::SSLeay::new($ctx) or die("Failed to create SSL $!");
    Net::SSLeay::set_fd($ssl, fileno(SOCK));   # filenogȂ΂Ȃ܂

    # gp\ȈÍASY̎w
    Net::SSLeay::set_cipher_list($ssl, $cipher);

    # ڑ݂
    my $res = Net::SSLeay::connect($ssl) and die_if_ssl_error(); 
    push @available_ciphers, Net::SSLeay::get_cipher($ssl);
    Net::SSLeay::free ($ssl);

    print $OUT "no error occured\n";
    close (SOCK);
    alarm(0);
  };
 
  if ($@){
    print $OUT $@ if ($@ =~ /^timeout/);
    close (SOCK);
  }  
  alarm(0);
}

print $OUT eval($fk_cmd) . "available ciphers are ....\n";
if ($#available_ciphers < 0) {
  print $OUT eval($fk_cmd) . "nothing\n";
  exit;
}else{
  #foreach my $cipher (@available_ciphers){
  #  print $OUT eval($fk_cmd) . $cipher . "\n";
  #}
  my $command = "$openssl ciphers -v '" . join(':',@available_ciphers) . "'";
  # print $OUT eval($fk_cmd) . $command . "\n";
  my @res = `$command`;
  foreach (@res){
    print $OUT eval($fk_cmd) . $_;
  }
}

# T[ȍؖɍs
eval{
  $SIG{'ALRM'} = sub { die "timeout" };
  alarm($timeout);
  
  socket  (SOCK, &AF_INET, &SOCK_STREAM, 0)  or die "socket error: $!";
  connect (SOCK, $remote) or die "connect error: $!";
  select( (select(SOCK), $|=1)[0] );  # obt@O̗}~

  $ctx = Net::SSLeay::CTX_new() or die_now("Failed to create SSL_CTX $!");
  Net::SSLeay::CTX_set_options($ctx, &Net::SSLeay::OP_ALL)
    and die_if_ssl_error("ssl ctx set options");
  $ssl = Net::SSLeay::new($ctx) or die_now("Failed to create SSL $!");
  Net::SSLeay::set_fd($ssl, fileno(SOCK));   # filenogȂ΂Ȃ܂

  alarm(0);
  
  # G[Net::SSLeayۉȂG[bZ[Wf̂
  print $OUT eval($fk_cmd) . "Getting server's certificate\n"; 
  print $OUT eval($fk_err); 

  alarm($timeout);

  my $res = Net::SSLeay::connect($ssl) and die_if_ssl_error(); 
  my $dump_cert_str = Net::SSLeay::dump_peer_certificate($ssl);
  my @dump_cert = split /\n/, $dump_cert_str;

  print $OUT "no error occured.\n";
  foreach (@dump_cert){
    print $OUT eval($fk_rcv) . $_ . "\n";
  }

  close (LOG) if ($opt_o);
  close (SOCK);
  alarm (0);
  exit;
};

alarm(0);

if ($@){
  print $OUT eval($fk_err) . "Cannot communicate with $target:$port over SSL correctly\n";
  close (LOG) if ($opt_o);
  close (SOCK);
  exit 1;
}

exit;

#print Net::SSLeay::dump_peer_certificate($ssl);



#my $server_cert = get_peer_certificate($ssl);
##print_errs('get_peer_certificate');
#if ($trace>1) {
##    warn "Cipher `" . get_cipher($ssl) . "'\n";
##    print_errs('get_ciper');
#    warn dump_peer_certificate($ssl);
#}

