#!/usr/bin/perl
#
# $B0z?t$H$7$FM?$($i$l$?%3%^%s%I$r<B9T$r$9$k%3!<%I(B. 
#
# $Id: do_cmd.pl,v 1.1 2005/12/10 17:54:02 hi-lo Exp $
use lib '../lib';
use Socket;

use lib '../conf';
use GConfig qw($fk_err $fk_cmd $fk_snd $fk_rcv);

use strict;

my $usage = qq{Usage: $0 [Options] command
command:     command
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  -p        port number ("_TARGET_PORT_" in command is replaced with this)
  -t        target host ("_TARGET_HOST_" in command is replaced with this)

};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_o $opt_h $opt_p $opt_t);

getopts('o:p:ht:') or die $usage;

die $usage if $opt_h;

# $B%3%^%s%I(B
die $usage if ($#ARGV < 0);
my $command = $ARGV[0];

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

# $BCV49(B
$command =~ s/_TARGET_PORT_/$opt_p/go if ($opt_p =~ /^\d+$/);
$command =~ s/_TARGET_HOST_/$opt_t/go;

my $port = $opt_p if ($opt_p =~ /^\d+$/);

print $OUT "=====BEGIN=====$0=====" . `date` ;
# $B%$%s%?%i%/%F%#%V$J<B9T$G$O$J$$$N$G(B, $B$3$l$G$h$7$H$9$k(B
my $send_command = $command . ' 2>&1';
print $OUT eval($fk_cmd) . "$send_command\n";

my @res = `$send_command`;

foreach (@res){
  chomp;
  print $OUT eval($fk_rcv) . "$_\n";
}

print $OUT "=====END=====$0=====" . `date` ;

close(LOG) if $opt_o;

exit 0;

