#!/usr/bin/perl
#
# nfs$B$N(BExport$B>pJs$r$H$C$F$/$k%3!<%I(B. 
#
# $Id: nfs_export.pl,v 1.8 2005/09/07 02:26:19 hi-lo Exp $
use lib '../lib';
use ConnectServer;
use Socket;

use lib '../conf';
use GConfig qw($showmount $fk_cmd $fk_snd $fk_rcv $fk_err);

use strict;

my $usage = qq{Usage: $0 [Options] target
target: IP or Hostname
Options:
  -h        show this message.
  -o        output logfile. (default: STDOUT)
  
};

# $B%*%W%7%g%s$N2r@O(B
use Getopt::Std;
use vars qw($opt_o $opt_p $opt_h $opt_s);

# -p $B$O(B, $B%@%_!<(B. $BB>$N%D!<%k$G(B, -p$B$,;H$($k$+$i(B, $B$=$l$KE}0l(B. 
getopts('o:p:h') or die $usage;

die $usage if $opt_h;

# $BBP>]%]!<%H$O(B2049$BHV%]!<%H$G8GDj(B
my $port = 2049;

# $BBP>]%[%9%HL>(B(IP$B%"%I%l%9(B)
my $target = $ARGV[0];

# $BBP>]%[%9%H$N;XDj$,$J$1$l$P%*%W%7%g%s$rI=<($7$F=*N;(B
die $usage unless  $target ;

# $B%?!<%2%C%H$,%[%9%HL>$GM?$($i$l$?>l9g$r9M$($F(B....
# inet_aton$B$O(BDNS$B$b0z$$$F$/$l$k(B.
my $target_ipn = inet_aton($target);
# inet_aton$B$N=PNO$r(BIP$B%"%I%l%9$KLa$9(B
my $target_ip= inet_ntoa($target_ipn);

# o$B%*%W%7%g%s$,$"$l$P%m%0%U%!%$%k$N%*!<%W%s(B
# $B%U%!%$%k%O%s%I%k$O(B, $B>e$G;XDj$7$?J8;zNs(B'LOG'
# $BCm0U(B: $B%U%!%$%k$X$ODI5-$7$^$9(B!
open(LOG, ">> $opt_o") or die "Can't open $opt_o: $!" if $opt_o;

# $B%m%0%U%!%$%k$N;XDj$NM-L5$rD4$Y$k(B($B;XDj$,$J$1$l$P(BSTDOUT$B$X=PNO(B)
my $OUT = $opt_o ? \*LOG : \*STDOUT;

my $port_comment = $opt_s ? ' over SSL' : '';
print $OUT "=====BEGIN=====Target: $target_ip:$port$port_comment=====" . `date` ;
# showmount$B$r;H$&(B. ($B%$%s%?%i%/%F%#%V$J<B9T$G$O$J$$$N$G(B, $B$3$l$G$h$7$H$9$k(B)
my $command = "$showmount -e $target_ip 2>&1";
print $OUT eval ($fk_cmd) . "$command\n";

my @response = `$command`;

for my $i (@response){
  print $OUT eval($fk_rcv) . $i;
}
  
print $OUT "=====END=====Target: $target_ip:$port$port_comment=====" . `date` ;

close(LOG) if $opt_o;

exit 0;

