#!/usr/bin/perl

# [𑗐MvO
# $Id: post_mail.pl,v 1.3 2005/12/10 09:58:46 hi-lo Exp $

use lib '../lib';
use PostMail;

use lib '../conf';
use GConfig ;

use strict;

my $usage = qq{Usage: $0 [Options]
Options:
  -h        show this message.
  -t        Address send mail to
  -m        message to send.
  -f        (use without -m) message file to send.
  -s        subject of mail.

};

# IvV̉
use Getopt::Std;
use vars qw($opt_t $opt_o $opt_p $opt_h $opt_m $opt_f $opt_s);
# -o -p  fk-grubver.plւAPI_~[ƂĎc

getopts('o:p:htm:f:s:') or die $usage;

die $usage if $opt_h;

my %header;
$header{'to'} = $opt_t ? $opt_t : $announce_send_to;
$header{'from'} = $announce_send_from;
$header{'subject'} = $announce_subject;
$header{'cc'} = $announce_cc;
$header{'reply_to'} = $announce_reply_to;
$header{'errors_to'} = $announce_errors_to;
$header{'date'} = $announce_date;

$header{'subject'} = $opt_s if ($opt_s);

my @msg = ("test_mail");
@msg = $opt_m if ($opt_m);
if (! $opt_m and $opt_f){
  open MSG_FILE, "< $opt_f" or die "cannot open $opt_f: $!";
  @msg = ();
  while (<MSG_FILE>){
    chomp;
    push @msg, $_;
  }
  close MSG_FILE;
}

my $sent_data_ptr = postmail (\%header, \@msg);

foreach (@{$sent_data_ptr}){
  print;
}

